#{


# Name :          Hatchfaces VER 1.8 beta    ########                                                             
# Description :   Create Hatches from faces  ########                                                       
# Author :        Joel Gustafsson.           ########                                                         
#                                                                                                     
# Original Module from TIG! http://forums.sketchucation.com/viewtopic.php?f=180&t=38481               
# Thanks to KYYU and JIM as well, for all help.                                                      
#                                                                                                   
#                                                                                                
# Date :          15.12.2o12                ########                                                  
#                                                                                                #############
#                                                                                                #/ / / / / /#                   
#                                                                                                # / / / / / #                                 
# Permission to use, copy, modify, and distribute this software for                              #/ / / / / /#                
# any purpose and without fee is hereby granted, provided that the above                         # / / / / / #               
# copyright notice appear in all copies.                                                         #/ / / / / /#                
#                                                                                                # / / / / / #               
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR                                   #/ / / / / /#               
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED                                 # / / / / / #                
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.                            #/ / / / / /#                
#                                                                                                # / / / / / #                
#                                                                                                #/ / / / / /#                
                                                                                                 #############
#ver 1.8 beta	#---------------------------#

#New.			New icons. 3 large + 3 small.

#New.			face_to_gpSlice. NOT a SECTIONCUTFACE version! A workflow-gadget. It only find faces in "slice from section" group.
#				Need optimizing, just functional at the moment. Difficult with nested groups and components.

#New.			CLEAN_HATCHES. Erases all edges but NOT Hatches inside a group. Also erases face edges that a component is glued to.
#				Distructive.
#				TODO: If users find these 2 methods useful and they are stable. Might incorporate them into the main script
#				so code gets less repetitive regarding collecting entities..

#New.		    BACKGROUND.
 
#New.			EDGECOLORING.

#New.			No edge need to be selected in Sketchup.

#New.			Attributes in Component-window. Might be neat if it poses no problems..

#New.			Hatches becomes components. It's under test, Not all users might like that..

#New.			By request there is only 1 component. Not 2 groups inside for ex. with crosshatching.
#
#New			Help-webdialog. It's for testing if my webdialog creation is working. No specific interaction
#				makes it easier to bugtrack. But there are icons(img) so there could be issues with Mac.
#				Anyway helpfiles are always good to have for the users..So time not wasted hopefully..
#
#       		A lot of speed-testing regarding geometry-creation has been made in this version. 
# 				Although I have found a slightly faster solution by exploding "ready edgegroups" onto face
#				I went for creating 2 or 3 separate groups intersecting them. This will maket it easier when porting skp.patterns later on.

#               So 1 face-group that intersects with either 1 or 2 patterns-groups.

#During tests..	Putting second cross-lines in first linegroup(gp1) and intersecting, results in missing faces sometimes.
#				Probably due to the lines in gp1 are not intersected before intersecting with face-clone.

#				Putting group2 in group1 and exploding prior to intersection with group1 is slo0OO0owww.

#				The first obvious method was to draw all geometry in 1 group. Face + edges and then intersect everything with itself.
#				But that's not so smart. Because when crosshatching one would have crossing edges outside the face(they will get erased anyway)
#				that would need intersecting(break edges). At least when grouping the face one limit that need.
#				
#				When introducing Background-face it must get glue.behavior at some point. And that poses some problems.
#
#				When creating geometry in "space" and not at ORIGIN. The normals gets mucked up.
#				The face need some reorientation for glue bahavior. TIG had a solution for 2dBoolean that very worked well.
#				In need for some more control I made up some new methods.
#
#				GP_TOGROUND, moves group to ground flat. Z axis aligned to Face.normal(glueable 2d geometry).
#				Cornerpoints can be used consistently, GLOBAL AXIS for whatever as well. 
#				When GP_TOGROUND I transport c_points from edge.start and edge.end. That way I still get "edge vector" for copying direction.
#				I use corner points if no edge is selected when the faceclone is on "ground".
#				After all geometry is created I use GP_TOFACE to get back to Sketchup's preselected face..
#
#				TODO: Add webdialog. Add Pattern hatching. Test if scaling the model up before hatching increases accuracy and/or speed.
#				+ lots more. Will try too release in small updates to see how progress is doing.



#ver 1.7 beta   Prompts-values variables are turned into @ to be remebered during sessions
#               Operationstack was after group creation wich is not good.
#				All in all just a bit of tidying up, nothing special. 
#
#ver 1.6 beta   Crosshatching added! Had to rearrange a lot of things.
#               Face creation, hatches and intersection to methods.  
#               A lot of method calling at the end, could be optimised?
#               
#               Methods have been created on my initiative, so if it doesent 
#               work, don't blame TIG:-)
#
#ver 1.5 beta   Slight regression, maybe. But in order to get control over
#               Hatch angles. An edge selection is now obligatory.
#               Pt to vector is taken from that edge selection.
#
#ver 1.4 beta   New solution From TIG for angle to vector. Based on world axis
#               Before when running the plugin the script took the first edge
#               and gathered pt to vector. That determined the hatch angle.
#               Some unpredictable results if faces where Ngons or distorted.              
#
#ver 1.3 beta   Important update. TIG's solution for holes seams to be working. 
#               Had hard time implementing it. Wasent sure where to put stuff. 
#               Menu items has been added for crosshatching. But they don't do anything yet.
#               Layer "Hatching" is created with hatching put to that layer.


#ver 1.2 beta   TIG added behavior of erasing Outer_frame. So now only crossed lines are kept.
#               Icons get an smaller update.

#ver 1.1 beta   Thanks to KYYU spacing got fixed.
#
#ver 1.0.beta   Issues:
#               There is still a lot of things to fix.
 
#               Faces with holes in them are problematic/don't work. 
#               Since the edge spacing function is irregular, aligning hatches next to each other
#               is difficult.


#               It would be cool to implement other hatchpatterns as well, but that's a different beast. 
#               Have som ideas about how to do that.          

#               My original script made use of grouping edges and copying them with intersection,
#               did not work inside a group.. 

#               This script make use of offsetting edges with intersection, erasing leftover edges...

#}


require 'sketchup.rb'

module Hatchfaces

#TODO! FIX iteration in face to gp slice. NEsting problems!

####CREATE-FACES-FROM-EDGES-(cmd2)-----------------------------------------------------------------------------------------------

def self.face_to_gpSlice() 
	
#---This method doesn't use section.plane in any way. But after "create group from slice"
#	that group is automatically. selected, so I take advantage of that situation.
#	There are really great tools for sectioncuts like Sectioncutface from TIG and Zorro2.

	ss = Sketchup.active_model.selection[0]   
	unless ss.is_a?(Sketchup::Group) or ss.is_a?(Sketchup::ComponentInstance)
		UI.messagebox("Select 1 group from section slice. Or 1 Component that needs face healing")
		return nil
    end
	gp = ss 
#---PROMPTS-DIALOG-----------------------------------------------
	@f_direction = "A-direction" if not @f_direction #
	title = "NUDGE DIRECTION"
	prompts = ["Direction? "]
	values = [@f_direction]
	list = ["A-direction|B-direction|No translation|Face-reversed|"]
	results_cut = UI.inputbox(prompts, values, list, title)
	return nil unless results_cut #User cancels
	@f_direction = results_cut[0]
	
	begin
		Sketchup.active_model.start_operation("slice_toface", true) # 1.8 begin-rescue-end instead of (version >7 ?)
	rescue
		Sketchup.active_model.start_operation('slice_toface')   
	end
	if results_cut 
		faces = []; edges = []
		gps2 = [] #Level 2 collection of groups and components..
		gps3 = [] #Level 3 collection of groups and components..
	
	#---Collect everything in arrays rather then going deep in an iterator(reccursive)?
		#This can be done in 1 iterator but result may vary. Code needs to be optimized later on.
		#Dangerous to make a loop out of this I think..
		
		# LEVEL1 
		self.gp_type(gp).entities.to_a.each{|e| 
			edges << e if e.is_a?(Sketchup::Edge) 
			gps2 << e if e.is_a?(Sketchup::Group) or e.is_a?(Sketchup::ComponentInstance)
		}
		# LEVEL 2
		gps2.each{|i| 
			if i.is_a?(Sketchup::Group) or i.is_a?(Sketchup::ComponentInstance)
				self.gp_type(i).entities.to_a.each{|e|
					edges << e if e.is_a?(Sketchup::Edge) 
					gps3  << e if e.is_a?(Sketchup::Group) or e.is_a?(Sketchup::ComponentInstance)
				}
			end
		}
		# LEVEL 3
		gps3.each{|j| 
			if j.is_a?(Sketchup::Group) or j.is_a?(Sketchup::ComponentInstance)
				self.gp_type(j).entities.to_a.each{|e|
					edges << e if e.is_a?(Sketchup::Edge) 
				}
			end
		}
		edges.uniq!
		edges.to_a.each{|e| e.find_faces } #have to create faces 1st before getting them...
		edges.to_a.each{|e| faces << e.faces[0] } #Actually we only need 1 face to get the face.normal.
		faces.uniq! #Otherwise some faces get reversed cause of duplicates??

	#---To be able to get the group visible from the cut, we translate it in face.normal reversed direction. 
		#Often one has to go in the opposite direction though, so we have that alternativ as well. 
		gp=self.gp_type(gp)
		fa_normal = faces[0].normal # Should be at least 1 Face, and ideally all on the same plane.
		fa_normal.length = 0.2.mm # Saw this nudge distance in sectioncut face from TIG. Gives a warning ! Float Out of range sometimes?
		tr = Geom::Transformation.translation(fa_normal)
		case @f_direction
			when "A-direction"; gp.entities.transform_entities(tr.inverse, gp.entities.to_a) # Direction of sectioncuts, HOPEFULLY! 
			when "B-direction"
				gp.entities.transform_entities(tr, gp.entities.to_a) # Trying other direction.
				faces.each{|f| f.reverse! if f.is_a?(Sketchup::Face)  } #Cause the faces will probably be reversed.
			when "Face-reversed"; faces.each{|f| f.reverse! if f.is_a?(Sketchup::Face) }
		else
			#"No translation" Just add faces... 
			#TODO...
		end	
	else
		return nil
	end
	Sketchup.active_model.commit_operation
end

def self.gp_type(gp)
	
	return case gp
		when Sketchup::ComponentInstance; gp=gp.definition
		when Sketchup::Group; gp=gp
	end
	
	
end

####HATCH-CLEAN-UP--"SLICE_FROM_SECTION"-(cmd3)--------------------------------##

def self.clean_Hatches() #Erase face.edges glued to HATCH

####Just a small workflow gadget. Erases section-group edges but NOT Hatches. Very BETA. 

#---Collect entities-----------------
	ss = Sketchup.active_model.selection
	if ss.empty?
		UI.messagebox("There is nothing selected?")
		return nil
    else
		group1=[]; comps=[]
		ss.to_a.each{|e| 
			if e.is_a?(Sketchup::Group)
				group1 << e
			elsif e.is_a?(Sketchup::ComponentInstance)
				comps << e
			else
				# code
			end
		}
	end
#---Start-Erasing--EDGES-----------------------##	
	begin
		Sketchup.active_model.start_operation("erase_borders", true) # 1.8 begin-rescue-end instead of (version >7 ?)
	rescue
		Sketchup.active_model.start_operation('erase_borders')   
	end	
	edges_2go=[]; edges_2keep=[] 
	if group1.length >= 1 #
		group1.to_a.each{|g| #Normally only 1 group selected.. 
			if g.is_a?(Sketchup::Group)
				next if not g.is_a?(Sketchup::Group)
				#g.make_unique # deprecated method=soon outdated?? http://sketchucation.com/forums/viewtopic.php?f=180&t=35375&p=312655&hilit=depreciated#p312655
				g.entities.to_a.each{|e| 
					if e.is_a?(Sketchup::Edge)  #Collect All edges
						edges_2go << e
					elsif e.is_a?(Sketchup::ComponentInstance) #Collect Hatchgroup edges. Keep them from getting erased.
						e.definition.entities.to_a.each{|edg| edges_2keep << edg if edg.is_a?(Sketchup::Edge) }
					end
				}
			end
		}
	end
	if comps.length >= 1 #If selecting HatchComponents ++.
		comps.to_a.each{|e| 
			if e.is_a?(Sketchup::ComponentInstance)
				if e.definition.behavior.cuts_opening? #If component is glued to a face..
					if e.glued_to and not nil # do NOT add nil to array edges_2go.
						e.glued_to.edges.to_a.each{|i| 
							edges_2go << i if i.valid?  #face.edges 
						}
					end
				end
			end
		}
	#else
		#TODO.......
	end	
	if edges_2go.empty? #if edges_2go.length < 1 or nil
		UI.messagebox("There is no group with HATCHCOMPONENTS selected")
		return nil
	else
		edges_2go = edges_2go - edges_2keep if edges_2keep
		edges_2go.uniq!
		Sketchup.active_model.active_entities.erase_entities(edges_2go)
	end
	Sketchup.active_model.commit_operation
end #end clean_Hatches..


####HELP-MENU-(Webdialog)--------experimental---------

def self.hatching_helpMenu() 
	
	#Just try to keep this as simple as possible. Read only.
#---HELP-FILE---in-DRAW-menu------------------------------------------------------
	help_html=File.join(File.dirname(__FILE__), "Hatchfaces/Webdialog/html/hatch_helpfiles.html")
	
#Webdialog------------------------------------
	default_options = {
		:dialog_title => 'Hatchfaces HELP',
		:scrollable => true,
		:preferences_key => 'Hatching',
		:height => 630,
		:width => 800,
		:left => 50,
		:top => 50,
		:resizable => true,
		:mac_only_use_nswindow => true #Don't know what this do..
	}
	@help_dialog = UI::WebDialog.new(default_options)
	@help_dialog.set_file(help_html)
	RUBY_PLATFORM =~ /(darwin)/ ? @help_dialog.show_modal() : @help_dialog.show
	@help_dialog.set_on_close{ @help_dialog = nil }
end

####Main-Methods----------------------#######

def self.face_clone(gents, faces)
	faces2go=[]
    faces.each{|face|
		face.loops.each{|loop|gents.add_face(loop.vertices)}   # make innerfaces and all faces
		@face=gents.add_face(face.outer_loop.vertices)         # make outer faces again to be sure
		gents.each{|face| 
			next if face.class!=Sketchup::Face     
			face.edges.each{|e|
				if not e.faces[1]
				break
				end
				faces2go << face
			}
		}
		gents.erase_entities(faces2go)   #erase inner faces(holes)
	}
end

def self.gp_toGround(group, face)#ver 1.8 
	
	#This method moves group flat to "ground" with face.normal in Z_AXIS. 
	#From there It is easier to handle geometry and Global Axes can be used for aligning stuff. 
	#Group bounds corner points can be calculated more consistently. 
	
	tr1=Geom::Transformation.new(face.bounds.center.project_to_plane(face.plane), face.normal)# Gets the Zaxis to face.normal(for group)
	group.transform!(tr1)
	#
	tr3=tr1.inverse#Moves ENTITIES back to face aligned to new AXIS.
	group.entities.transform_entities(tr3, group.entities.to_a)
	#
	group.entities.parent.invalidate_bounds#Refresh groups boundingbox to fit entities.
	group.transform!(tr3)#Moves GROUP to ORIGIN

end

def self.hatching(angle, spacing, gents)    
	
	bb = @face.bounds
	di = bb.diagonal
	pt = @edge_start.position;
	pt2= @edge_end.position
	ve = pt.vector_to(pt2)
	po = pt.clone
	tr = Geom::Transformation.rotation(pt, @face.normal, angle.degrees)
	vp = ve.transform(tr)
	vp.length=di
	vs = @face.normal.cross(vp) #spacing vector perpendicular to hatch line
    tot= 0
	until tot>=di
		ps = pt.offset(vp)
		pe = pt.offset(vp.reverse)
		gents.add_line(ps,pe)
		pt.offset!(vs,spacing)
		ps = po.offset(vp)
		pe = po.offset(vp.reverse)
		gents.add_line(ps,pe)
		po.offset!(vs.reverse,spacing)
		tot= tot+spacing
	end#until
end

def self.faceOps(gents) 
	edges2go=[]; gents.each{|e|edges2go << e if e.is_a?(Sketchup::Edge) and not e.faces[1]}; gents.erase_entities(edges2go) #remove Border.
	gents.to_a.each{|e|e.erase! if e.valid? and e.is_a?(Sketchup::Face)} #just to be sure erase remaining faces.
end 

def self.intersect_1(group1, group2) 
	tr = Geom::Transformation.new()
	group1.entities.intersect_with(true, tr, group1.entities, tr, true, group2.entities.to_a)
end 

def self.hideOuterEgdes(gents) #ver 1.8 
	gents.to_a.each{|e| e.hidden=true if e.is_a?(Sketchup::Edge) }  #we don't need no trap. All edges need to get hidden.
end

def self.getmaterials()#ver 1.8 
	mat_names=[]
	Sketchup.active_model.materials.each {|e| mat_names << e.name }#.gsub(/[^_0-9A-Za-z]/, '')} 
	return mat_names.sort.join('|')
end

def self.getlayers()#Get model.layers to string
	layers=[]
	Sketchup.active_model.layers.to_a.each { |l| layers << l.name } 
	return layers.sort.join('|') #join each listitem with "|". Use with .split"|" later on.		
end

def self.face_mats(gents) #ver 1.8 
	gents.to_a.each{|e| e.material = @backgr_col if e.is_a?(Sketchup::Face) } 
end

def self.edge_mats(gents) #ver 1.8  !Color by materials must be on in styles.
	gents.to_a.each{|e| e.material = @edg_col if e.is_a?(Sketchup::Edge) }
end

def self.gp_toFace(group, face) #ver 1.8  #Moves a group to face and aligns it with the face.normal(IF flat at ORIGIN) 
	fbc = face.bounds.center; fbc = fbc.project_to_plane(face.plane)
	tr1 = Geom::Transformation.new(fbc, face.normal)
	group.transform!(tr1)
end

def self.gluto_face(group, face) #ver 1.8 
	group.entities.parent.invalidate_bounds#Refresh boundingbox
	inst = group.to_component
	defn = inst.definition
	unless @backgr_col == false
		be = defn.behavior
		be.is2d = true
		be.cuts_opening = true
		#be.receives_shadows=false
		be.snapto = 0
		inst.glued_to = face
	end
	self.naming_andLayers(inst)
	return @edg_col == "None" ?  inst : self.set_Hatch_attr(defn) #TODO use false and not "None", but @value dont get remembered?

end #end gluto

def self.set_Hatch_attr(defn)
	#!TODO! clean this attribute code up. Bloody mess..
	#In order to get the attributes in the right order in the Component window, arrange the "keys" with a prefix, _a, _b etc..
	#Try too keep attributes at a minimum, so files don't get too large.
	
	#title
	defn.set_attribute('dynamic_attributes', 'summary', '<b>LINEHATCHING<b>')
	#angle1
	defn.set_attribute('dynamic_attributes', 'a_hatchangle1', "#{@angle.to_s}")
	defn.set_attribute('dynamic_attributes', '_a_hatchangle1_formlabel', 'Angle:')
	defn.set_attribute('dynamic_attributes', '_a_hatchangle1_units', 'STRING')
	defn.set_attribute('dynamic_attributes', '_a_hatchangle1_access', 'VIEW')
	#spacing1
	defn.set_attribute('dynamic_attributes', 'b_spacing1', "#{@spacing.to_s}")
	defn.set_attribute('dynamic_attributes', '_b_spacing1_formlabel', 'Spacing:')
	defn.set_attribute('dynamic_attributes', '_b_spacing1_units', 'STRING')
	defn.set_attribute('dynamic_attributes', '_b_spacing1_access', 'VIEW')
	#angle2
	if @cross_alt == "Yes"
		defn.set_attribute('dynamic_attributes', 'c_crossangle', "#{@angle2.to_s}")
		defn.set_attribute('dynamic_attributes', '_c_crossangle_formlabel', 'Angle2:')
		defn.set_attribute('dynamic_attributes', '_c_crossangle_units', 'STRING')
		defn.set_attribute('dynamic_attributes', '_c_crossangle_access', 'VIEW')
	#spacing2
		defn.set_attribute('dynamic_attributes', 'd_spacing2', "#{@spacing2.to_s}")
		defn.set_attribute('dynamic_attributes', '_d_spacing2_formlabel', 'Spacing2:')
		defn.set_attribute('dynamic_attributes', '_d_spacing2_units', 'STRING')
		defn.set_attribute('dynamic_attributes', '_d_spacing2_access', 'VIEW')
	end
end

def self.naming_andLayers(inst)
	model = Sketchup.active_model
	defs  = model.definitions
	name  = 'Line-Hatching#1'
	inst.definition.name = name
    hatch_layer = model.layers.add("HATCHING") unless hatch_layer
	inst.layer  = @hatch_layer
	names=[] 
	defs.each{|d|names << d.instances[0].name if d.is_a?(Sketchup::ComponentInstance) }
	name.next! while names.include?(name)
end


####HATCHING--(cmd0)---------------------------------########
def self.hatchfaces() 

#---MAIN--SCRIPT--HATCHFACES-------------------#
	model = Sketchup.active_model
	ents  = model.active_entities
	ss = model.selection
	if ss.empty?
		UI.messagebox("Please select a Face") #1.8 was edge not selected alert!
		return nil
	else
		@face=nil #will become face.clone.#1.8 
		@edge=nil 
		faces=[] #Use faces[0] as Sketchup Face.selection. @face is face-clone #1.8
		edges=[]
	#---Collect-selections-from Skecthup----    
		ss.each{|e|
			if e.is_a?(Sketchup::Face)
				faces << e
			elsif e.is_a?(Sketchup::Edge)
				edges << e
			end
		}
		edges.empty? ? edges.clear : @edge = edges[0] #perhaps not necessary
		if faces.length > 1 #At the moment its only possible to work with 1 face. Can only glue to 1 face anyway!
			UI.messagebox("Please select only 1 face") #gives an error in code later otherwise.!
			return nil
		end
	end

#---HATCH-DIALOG -------------------------------------------
	#Initilize-values-and defaults-
	@angle = 45.0 unless @angle
	@spacing = 20.to_l unless @spacing # 1.7 fix @Values should be remembered during session.
	@cross_alt = "No" unless @cross_alt # ver 1.8 Should remember crosshatching 
	@backgr_col = "<Default>" unless @backgr_col #NONE destroys faces and "face-borders" !
	@edg_col = "<Default>" unless @edg_col
	@hatch_layer = "HATCHING" unless @hatch_layer #It may not have been created yet..
	hatch_lay_arr = self.getlayers()
	face_mats_arr = self.getmaterials() 
	edge_mats_arr = face_mats_arr
	
#---PROMPTS-dialog1-------
	title = "Hatchfaces Parameters"
	prompts = ["Angle(deg): ", "Spacing: ", "Background Color", "Edge Color", "Layer", "Cross-Hatching?"]
	vals = [@angle, @spacing, @backgr_col, @edg_col, @hatch_layer, @cross_alt]
	list = ["", "", "None|<Default>|" + face_mats_arr, "None|<Default>|" + edge_mats_arr, "HATCHING|" +  hatch_lay_arr, "Yes|No"]
	results = UI.inputbox(prompts, vals, list, title)
	return nil unless results # i.e. the user canceled
#---Results-from-dialog1-----	
	@angle = results[0] 
	@spacing = results[1] 
	@backgr_col = results[2] 
	@edg_col = results[3] 
	@hatch_layer = results[4] 
	@cross_alt = results[5]
#--------------------------
	case @backgr_col
		when "None"; @backgr_col=false
		when "<Default>"; @backgr_col=nil 
		else; @backgr_col = results[2] #if color
	end
	
#Start--HATCHFACES-----------
	begin
		start_time = Time.new
		begin
			model.start_operation("hatchfaces", true) # 1.8 begin-rescue-end instead of (version >7 ?)
		rescue
			model.start_operation('hatchfaces')   
		end
	#---HATCHING-----------------------------------------------	
		gp = ents.add_group(); gents = gp.entities #Background Group.
		self.face_clone(gents, faces)
		if edges[0] #add c_points that follows the trip to ground.
			if edges[0].reversed_in? faces[0]
				@edge_end   = gents.add_cpoint(edges[0].start.position)
				@edge_start = gents.add_cpoint(edges[0].end.position)
			else
				@edge_start = gents.add_cpoint(edges[0].start.position)
				@edge_end   = gents.add_cpoint(edges[0].end.position)
			end
		end
		self.gp_toGround(gp, faces[0]) #Face flat. Normal at Z..
		unless edges[0] #cheat in "fake" @edg.start and @edg.end.
			@edge_start = gents.add_cpoint(gp.bounds.corner(0)) 
			@edge_end   = gents.add_cpoint(gp.bounds.corner(1))
		end
		unless @backgr_col == false
			self.hideOuterEgdes(gents) #Hide face border.
			self.face_mats(gents) #Background color
		end
	#---EDGE-COLOR-AND BACKGROUND-ONLY------------
		case @edg_col
			when "None"
				#@edg_col = false #Dont remember value? TODO!
				if @backgr_col == false 
					gp.erase!
					UI.messagebox("There must be a Background if 'None' in edgecolor is choosen") #1.8 was edge not selected alert!
					return nil #exiting
				else
					self.gp_toFace(gp, faces[0]) #Back to Sketchup selection without edge-hatch.
					self.gluto_face(gp, faces[0])
					@edge_start.erase!; @edge_end.erase! #no longer needed c_points.
					model.commit_operation 
					return nil #exiting Hatchfaces. 
				end
			when "<Default>"; @edg_col = nil
			#else; @edg_col=results[3] #selected color
		end
	#---HATCH-GROUP1----------------------------	
		gp1 = ents.add_group() 
		self.hatching(@angle, @spacing, gp1.entities)
		if 	@cross_alt == "Yes"  
			@angle2 = -@angle unless @angle2 
			@spacing2 = @spacing  # ver 1.8 most times user want same as @spacing?
		#---PROMPTS-dialog2-------	
			title2 = "Crosshatching Parameters"
			prompts2 = ["Angle(deg): ", "Spacing: "]
			values2 = [@angle2, @spacing2] 
			results2 = UI.inputbox(prompts2, values2, title2)
			return nil unless results2 
		#---Results-dialog2----
			@angle2 = results2[0]
			@spacing2 = results2[1]
		#--------------------------	
			gp2 = ents.add_group() ##HATCH GROUP2. Putting lines in gp1 slow things down. 
			self.hatching(@angle2, @spacing2, gp2.entities)
			self.intersect_1(gp, gp2)
			gp2.erase! #no longer needed Group.
		end #End creating Hatch-Geometry-----
		self.intersect_1(gp, gp1)#Running this before crosshatch destroys @face!
		gp1.erase!; @edge_start.erase!; @edge_end.erase! #no longer needed items.
		#---EDGE-COLORS-------------
		@backgr_col == false ? self.faceOps(gents) : false #Clears the faces and border.
		self.edge_mats(gents)
	#---MOVE-BACK-TO-FACE-AND-GLUE-------------	
		self.gp_toFace(gp, faces[0])
		self.gluto_face(gp, faces[0])# if @backgr_col!=false
		
	model.commit_operation 
	
	rescue 	Exception => e
		model.abort_operation('hatchfaces')
		puts("Error #<#{e.class.name}:#{e.message}.>")
		puts(e.backtrace) if $VERBOSE
	else
		#
				
		#
	ensure
		#
		end_time = Time.new
		total_time = end_time - start_time
		puts total_time.to_s + " seconds "
		#ss.clear
		#Sketchup.active_model.active_view.refresh 
		#
	end #begin..

	
end #end hatchfaces.. 
  ##############Menu stuff###########
unless file_loaded?("Hatchfaces.rb")
	toolbar = UI::Toolbar.new("Hatchfaces")
	cmd0 = UI::Command.new("Hatchfaces") { self.hatchfaces() }
	cmd0.small_icon = File.join(File.dirname(__FILE__), "Hatchfaces/hatching_sm.png")
	cmd0.large_icon = File.join(File.dirname(__FILE__), "Hatchfaces/hatching_lg.png")
	cmd0.tooltip = "Hatched lines"
	cmd0.status_bar_text = "Hatch face"
	cmd0.menu_text = "Hatching"
	#cmd2#
	cmd2 = UI::Command.new("Hatchfaces") { self.face_to_gpSlice() } #Call separate method! Group detection is reserved for future features.
	cmd2.small_icon = File.join(File.dirname(__FILE__), "Hatchfaces/sectionface_sm.png")  
	cmd2.large_icon = File.join(File.dirname(__FILE__), "Hatchfaces/sectionface_lg.png") 
	cmd2.tooltip = "Heal section-group-slice"
	cmd2.status_bar_text = "faces to section-slice"
	cmd2.menu_text = "Sectionface"
	#cmd3#
	cmd3 = UI::Command.new("Hatchfaces") { self.clean_Hatches() } #Call separate method! Group detection is reserved for future features.
	cmd3.small_icon = File.join(File.dirname(__FILE__), "Hatchfaces/clearborders_sm.png") 
	cmd3.large_icon = File.join(File.dirname(__FILE__), "Hatchfaces/clearborders_lg.png") 
	cmd3.tooltip = "Clean up Hatches"
	cmd3.status_bar_text = "Delete edges underneath hatch"
	#add toolbar
	toolbar.add_item(cmd0) 
	toolbar.add_item(cmd2)
	toolbar.add_item(cmd3)
	toolbar.show
	
 ### Draw menu ################
	UI.menu("Draw").add_separator
	hatchmenu=UI.menu("Draw").add_submenu("Hatchfaces...")
	hatchmenu.add_item("Line hatching"){self.hatchfaces()}
	hatchmenu.add_item("Heal Faces"){self.face_to_gpSlice()}
	hatchmenu.add_item("Clean Hatches"){self.clean_Hatches()}
	hatchmenu.add_item("Help"){self.hatching_helpMenu()}
end
file_loaded("Hatchfaces.rb") 

end #module
#---
